/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "parser.y"


/*
 *   Copyright (C) 2006-2010  Michael Buesch <m@bues.ch>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License version 2
 *   as published by the Free Software Foundation.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */

#include "main.h"
#include "initvals.h"
#include "util.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdint.h>

extern char *yytext;
extern void yyerror(const char *);
extern int yyparse(void);
extern int yylex(void);

static struct operand * store_oper_sanity(struct operand *oper);
static void assembler_assertion_failed(void);

/* The current .section */
extern int section;
/* Pointer to the current initvals section data structure. */
extern struct initvals_sect *cur_initvals_sect;


#line 110 "parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_SECTION_TEXT = 3,               /* SECTION_TEXT  */
  YYSYMBOL_SECTION_IVALS = 4,              /* SECTION_IVALS  */
  YYSYMBOL_ASM_ARCH = 5,                   /* ASM_ARCH  */
  YYSYMBOL_ASM_START = 6,                  /* ASM_START  */
  YYSYMBOL_ASM_ASSERT = 7,                 /* ASM_ASSERT  */
  YYSYMBOL_SPR = 8,                        /* SPR  */
  YYSYMBOL_GPR = 9,                        /* GPR  */
  YYSYMBOL_OFFR = 10,                      /* OFFR  */
  YYSYMBOL_LR = 11,                        /* LR  */
  YYSYMBOL_COMMA = 12,                     /* COMMA  */
  YYSYMBOL_SEMICOLON = 13,                 /* SEMICOLON  */
  YYSYMBOL_BRACK_OPEN = 14,                /* BRACK_OPEN  */
  YYSYMBOL_BRACK_CLOSE = 15,               /* BRACK_CLOSE  */
  YYSYMBOL_PAREN_OPEN = 16,                /* PAREN_OPEN  */
  YYSYMBOL_PAREN_CLOSE = 17,               /* PAREN_CLOSE  */
  YYSYMBOL_HEXNUM = 18,                    /* HEXNUM  */
  YYSYMBOL_DECNUM = 19,                    /* DECNUM  */
  YYSYMBOL_ARCH_NEWWORLD = 20,             /* ARCH_NEWWORLD  */
  YYSYMBOL_ARCH_OLDWORLD = 21,             /* ARCH_OLDWORLD  */
  YYSYMBOL_LABEL = 22,                     /* LABEL  */
  YYSYMBOL_IDENT = 23,                     /* IDENT  */
  YYSYMBOL_LABELREF = 24,                  /* LABELREF  */
  YYSYMBOL_EQUAL = 25,                     /* EQUAL  */
  YYSYMBOL_NOT_EQUAL = 26,                 /* NOT_EQUAL  */
  YYSYMBOL_LOGICAL_OR = 27,                /* LOGICAL_OR  */
  YYSYMBOL_LOGICAL_AND = 28,               /* LOGICAL_AND  */
  YYSYMBOL_PLUS = 29,                      /* PLUS  */
  YYSYMBOL_MINUS = 30,                     /* MINUS  */
  YYSYMBOL_MULTIPLY = 31,                  /* MULTIPLY  */
  YYSYMBOL_DIVIDE = 32,                    /* DIVIDE  */
  YYSYMBOL_BITW_OR = 33,                   /* BITW_OR  */
  YYSYMBOL_BITW_AND = 34,                  /* BITW_AND  */
  YYSYMBOL_BITW_XOR = 35,                  /* BITW_XOR  */
  YYSYMBOL_BITW_NOT = 36,                  /* BITW_NOT  */
  YYSYMBOL_LEFTSHIFT = 37,                 /* LEFTSHIFT  */
  YYSYMBOL_RIGHTSHIFT = 38,                /* RIGHTSHIFT  */
  YYSYMBOL_OP_MUL = 39,                    /* OP_MUL  */
  YYSYMBOL_OP_ADD = 40,                    /* OP_ADD  */
  YYSYMBOL_OP_ADDSC = 41,                  /* OP_ADDSC  */
  YYSYMBOL_OP_ADDC = 42,                   /* OP_ADDC  */
  YYSYMBOL_OP_ADDSCC = 43,                 /* OP_ADDSCC  */
  YYSYMBOL_OP_SUB = 44,                    /* OP_SUB  */
  YYSYMBOL_OP_SUBSC = 45,                  /* OP_SUBSC  */
  YYSYMBOL_OP_SUBC = 46,                   /* OP_SUBC  */
  YYSYMBOL_OP_SUBSCC = 47,                 /* OP_SUBSCC  */
  YYSYMBOL_OP_SRA = 48,                    /* OP_SRA  */
  YYSYMBOL_OP_OR = 49,                     /* OP_OR  */
  YYSYMBOL_OP_AND = 50,                    /* OP_AND  */
  YYSYMBOL_OP_XOR = 51,                    /* OP_XOR  */
  YYSYMBOL_OP_SR = 52,                     /* OP_SR  */
  YYSYMBOL_OP_SRX = 53,                    /* OP_SRX  */
  YYSYMBOL_OP_SL = 54,                     /* OP_SL  */
  YYSYMBOL_OP_RL = 55,                     /* OP_RL  */
  YYSYMBOL_OP_RR = 56,                     /* OP_RR  */
  YYSYMBOL_OP_NAND = 57,                   /* OP_NAND  */
  YYSYMBOL_OP_ORX = 58,                    /* OP_ORX  */
  YYSYMBOL_OP_MOV = 59,                    /* OP_MOV  */
  YYSYMBOL_OP_JMP = 60,                    /* OP_JMP  */
  YYSYMBOL_OP_JAND = 61,                   /* OP_JAND  */
  YYSYMBOL_OP_JNAND = 62,                  /* OP_JNAND  */
  YYSYMBOL_OP_JS = 63,                     /* OP_JS  */
  YYSYMBOL_OP_JNS = 64,                    /* OP_JNS  */
  YYSYMBOL_OP_JE = 65,                     /* OP_JE  */
  YYSYMBOL_OP_JNE = 66,                    /* OP_JNE  */
  YYSYMBOL_OP_JLS = 67,                    /* OP_JLS  */
  YYSYMBOL_OP_JGES = 68,                   /* OP_JGES  */
  YYSYMBOL_OP_JGS = 69,                    /* OP_JGS  */
  YYSYMBOL_OP_JLES = 70,                   /* OP_JLES  */
  YYSYMBOL_OP_JL = 71,                     /* OP_JL  */
  YYSYMBOL_OP_JGE = 72,                    /* OP_JGE  */
  YYSYMBOL_OP_JG = 73,                     /* OP_JG  */
  YYSYMBOL_OP_JLE = 74,                    /* OP_JLE  */
  YYSYMBOL_OP_JZX = 75,                    /* OP_JZX  */
  YYSYMBOL_OP_JNZX = 76,                   /* OP_JNZX  */
  YYSYMBOL_OP_JEXT = 77,                   /* OP_JEXT  */
  YYSYMBOL_OP_JNEXT = 78,                  /* OP_JNEXT  */
  YYSYMBOL_OP_JDN = 79,                    /* OP_JDN  */
  YYSYMBOL_OP_JDPZ = 80,                   /* OP_JDPZ  */
  YYSYMBOL_OP_JDP = 81,                    /* OP_JDP  */
  YYSYMBOL_OP_JDNZ = 82,                   /* OP_JDNZ  */
  YYSYMBOL_OP_CALL = 83,                   /* OP_CALL  */
  YYSYMBOL_OP_CALLS = 84,                  /* OP_CALLS  */
  YYSYMBOL_OP_RET = 85,                    /* OP_RET  */
  YYSYMBOL_OP_RETS = 86,                   /* OP_RETS  */
  YYSYMBOL_OP_TKIPH = 87,                  /* OP_TKIPH  */
  YYSYMBOL_OP_TKIPHS = 88,                 /* OP_TKIPHS  */
  YYSYMBOL_OP_TKIPL = 89,                  /* OP_TKIPL  */
  YYSYMBOL_OP_TKIPLS = 90,                 /* OP_TKIPLS  */
  YYSYMBOL_OP_NAP = 91,                    /* OP_NAP  */
  YYSYMBOL_RAW_CODE = 92,                  /* RAW_CODE  */
  YYSYMBOL_IVAL_MMIO16 = 93,               /* IVAL_MMIO16  */
  YYSYMBOL_IVAL_MMIO32 = 94,               /* IVAL_MMIO32  */
  YYSYMBOL_IVAL_PHY = 95,                  /* IVAL_PHY  */
  YYSYMBOL_IVAL_RADIO = 96,                /* IVAL_RADIO  */
  YYSYMBOL_IVAL_SHM16 = 97,                /* IVAL_SHM16  */
  YYSYMBOL_IVAL_SHM32 = 98,                /* IVAL_SHM32  */
  YYSYMBOL_IVAL_TRAM = 99,                 /* IVAL_TRAM  */
  YYSYMBOL_YYACCEPT = 100,                 /* $accept  */
  YYSYMBOL_line = 101,                     /* line  */
  YYSYMBOL_line_terminator = 102,          /* line_terminator  */
  YYSYMBOL_section_switch = 103,           /* section_switch  */
  YYSYMBOL_ivals_write = 104,              /* ivals_write  */
  YYSYMBOL_statement = 105,                /* statement  */
  YYSYMBOL_asmdir = 106,                   /* asmdir  */
  YYSYMBOL_asm_assert = 107,               /* asm_assert  */
  YYSYMBOL_assertion = 108,                /* assertion  */
  YYSYMBOL_assert_expr = 109,              /* assert_expr  */
  YYSYMBOL_label = 110,                    /* label  */
  YYSYMBOL_insn_mul = 111,                 /* insn_mul  */
  YYSYMBOL_insn_add = 112,                 /* insn_add  */
  YYSYMBOL_insn_addsc = 113,               /* insn_addsc  */
  YYSYMBOL_insn_addc = 114,                /* insn_addc  */
  YYSYMBOL_insn_addscc = 115,              /* insn_addscc  */
  YYSYMBOL_insn_sub = 116,                 /* insn_sub  */
  YYSYMBOL_insn_subsc = 117,               /* insn_subsc  */
  YYSYMBOL_insn_subc = 118,                /* insn_subc  */
  YYSYMBOL_insn_subscc = 119,              /* insn_subscc  */
  YYSYMBOL_insn_sra = 120,                 /* insn_sra  */
  YYSYMBOL_insn_or = 121,                  /* insn_or  */
  YYSYMBOL_insn_and = 122,                 /* insn_and  */
  YYSYMBOL_insn_xor = 123,                 /* insn_xor  */
  YYSYMBOL_insn_sr = 124,                  /* insn_sr  */
  YYSYMBOL_insn_srx = 125,                 /* insn_srx  */
  YYSYMBOL_insn_sl = 126,                  /* insn_sl  */
  YYSYMBOL_insn_rl = 127,                  /* insn_rl  */
  YYSYMBOL_insn_rr = 128,                  /* insn_rr  */
  YYSYMBOL_insn_nand = 129,                /* insn_nand  */
  YYSYMBOL_insn_orx = 130,                 /* insn_orx  */
  YYSYMBOL_insn_mov = 131,                 /* insn_mov  */
  YYSYMBOL_insn_jmp = 132,                 /* insn_jmp  */
  YYSYMBOL_insn_jand = 133,                /* insn_jand  */
  YYSYMBOL_insn_jnand = 134,               /* insn_jnand  */
  YYSYMBOL_insn_js = 135,                  /* insn_js  */
  YYSYMBOL_insn_jns = 136,                 /* insn_jns  */
  YYSYMBOL_insn_je = 137,                  /* insn_je  */
  YYSYMBOL_insn_jne = 138,                 /* insn_jne  */
  YYSYMBOL_insn_jls = 139,                 /* insn_jls  */
  YYSYMBOL_insn_jges = 140,                /* insn_jges  */
  YYSYMBOL_insn_jgs = 141,                 /* insn_jgs  */
  YYSYMBOL_insn_jles = 142,                /* insn_jles  */
  YYSYMBOL_insn_jl = 143,                  /* insn_jl  */
  YYSYMBOL_insn_jge = 144,                 /* insn_jge  */
  YYSYMBOL_insn_jg = 145,                  /* insn_jg  */
  YYSYMBOL_insn_jle = 146,                 /* insn_jle  */
  YYSYMBOL_insn_jzx = 147,                 /* insn_jzx  */
  YYSYMBOL_insn_jnzx = 148,                /* insn_jnzx  */
  YYSYMBOL_insn_jdn = 149,                 /* insn_jdn  */
  YYSYMBOL_insn_jdpz = 150,                /* insn_jdpz  */
  YYSYMBOL_insn_jdp = 151,                 /* insn_jdp  */
  YYSYMBOL_insn_jdnz = 152,                /* insn_jdnz  */
  YYSYMBOL_insn_jext = 153,                /* insn_jext  */
  YYSYMBOL_insn_jnext = 154,               /* insn_jnext  */
  YYSYMBOL_linkreg = 155,                  /* linkreg  */
  YYSYMBOL_insn_call = 156,                /* insn_call  */
  YYSYMBOL_insn_calls = 157,               /* insn_calls  */
  YYSYMBOL_insn_ret = 158,                 /* insn_ret  */
  YYSYMBOL_insn_rets = 159,                /* insn_rets  */
  YYSYMBOL_insn_tkiph = 160,               /* insn_tkiph  */
  YYSYMBOL_insn_tkiphs = 161,              /* insn_tkiphs  */
  YYSYMBOL_insn_tkipl = 162,               /* insn_tkipl  */
  YYSYMBOL_insn_tkipls = 163,              /* insn_tkipls  */
  YYSYMBOL_insn_nap = 164,                 /* insn_nap  */
  YYSYMBOL_insn_raw = 165,                 /* insn_raw  */
  YYSYMBOL_raw_code = 166,                 /* raw_code  */
  YYSYMBOL_extended_operlist = 167,        /* extended_operlist  */
  YYSYMBOL_external_jump_operands = 168,   /* external_jump_operands  */
  YYSYMBOL_operlist_2 = 169,               /* operlist_2  */
  YYSYMBOL_operlist_3 = 170,               /* operlist_3  */
  YYSYMBOL_operand = 171,                  /* operand  */
  YYSYMBOL_reg = 172,                      /* reg  */
  YYSYMBOL_mem = 173,                      /* mem  */
  YYSYMBOL_imm = 174,                      /* imm  */
  YYSYMBOL_imm_value = 175,                /* imm_value  */
  YYSYMBOL_complex_imm = 176,              /* complex_imm  */
  YYSYMBOL_complex_imm_oper = 177,         /* complex_imm_oper  */
  YYSYMBOL_complex_imm_arg = 178,          /* complex_imm_arg  */
  YYSYMBOL_complex_imm_const = 179,        /* complex_imm_const  */
  YYSYMBOL_hexnum = 180,                   /* hexnum  */
  YYSYMBOL_decnum = 181,                   /* decnum  */
  YYSYMBOL_hexnum_decnum = 182,            /* hexnum_decnum  */
  YYSYMBOL_labelref = 183,                 /* labelref  */
  YYSYMBOL_regnr = 184,                    /* regnr  */
  YYSYMBOL_identifier = 185                /* identifier  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   353

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  100
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  86
/* YYNRULES -- Number of rules.  */
#define YYNRULES  182
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  321

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   354


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    54,    54,    57,    66,    68,    79,    80,    83,    86,
     108,   115,   122,   129,   136,   144,   152,   161,   172,   179,
     186,   193,   200,   207,   214,   221,   228,   235,   242,   249,
     256,   263,   270,   277,   284,   291,   298,   305,   312,   319,
     326,   333,   340,   347,   354,   361,   368,   375,   382,   389,
     396,   403,   410,   417,   424,   431,   438,   445,   452,   459,
     466,   473,   480,   487,   494,   501,   508,   515,   522,   529,
     536,   543,   550,   560,   566,   575,   580,   588,   591,   597,
     605,   611,   619,   630,   639,   648,   657,   666,   675,   684,
     693,   702,   710,   718,   726,   734,   742,   750,   758,   766,
     774,   782,   790,   798,   806,   816,   824,   832,   840,   848,
     856,   864,   872,   880,   888,   896,   904,   912,   920,   928,
     936,   944,   952,   960,   968,   976,   984,   992,   997,  1015,
    1033,  1054,  1075,  1091,  1107,  1123,  1139,  1160,  1169,  1175,
    1192,  1203,  1211,  1220,  1226,  1232,  1238,  1244,  1249,  1255,
    1262,  1270,  1278,  1289,  1296,  1299,  1304,  1342,  1345,  1349,
    1354,  1359,  1362,  1365,  1368,  1371,  1374,  1377,  1380,  1383,
    1388,  1391,  1396,  1399,  1406,  1417,  1422,  1425,  1430,  1439,
    1448,  1459,  1464
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "SECTION_TEXT",
  "SECTION_IVALS", "ASM_ARCH", "ASM_START", "ASM_ASSERT", "SPR", "GPR",
  "OFFR", "LR", "COMMA", "SEMICOLON", "BRACK_OPEN", "BRACK_CLOSE",
  "PAREN_OPEN", "PAREN_CLOSE", "HEXNUM", "DECNUM", "ARCH_NEWWORLD",
  "ARCH_OLDWORLD", "LABEL", "IDENT", "LABELREF", "EQUAL", "NOT_EQUAL",
  "LOGICAL_OR", "LOGICAL_AND", "PLUS", "MINUS", "MULTIPLY", "DIVIDE",
  "BITW_OR", "BITW_AND", "BITW_XOR", "BITW_NOT", "LEFTSHIFT", "RIGHTSHIFT",
  "OP_MUL", "OP_ADD", "OP_ADDSC", "OP_ADDC", "OP_ADDSCC", "OP_SUB",
  "OP_SUBSC", "OP_SUBC", "OP_SUBSCC", "OP_SRA", "OP_OR", "OP_AND",
  "OP_XOR", "OP_SR", "OP_SRX", "OP_SL", "OP_RL", "OP_RR", "OP_NAND",
  "OP_ORX", "OP_MOV", "OP_JMP", "OP_JAND", "OP_JNAND", "OP_JS", "OP_JNS",
  "OP_JE", "OP_JNE", "OP_JLS", "OP_JGES", "OP_JGS", "OP_JLES", "OP_JL",
  "OP_JGE", "OP_JG", "OP_JLE", "OP_JZX", "OP_JNZX", "OP_JEXT", "OP_JNEXT",
  "OP_JDN", "OP_JDPZ", "OP_JDP", "OP_JDNZ", "OP_CALL", "OP_CALLS",
  "OP_RET", "OP_RETS", "OP_TKIPH", "OP_TKIPHS", "OP_TKIPL", "OP_TKIPLS",
  "OP_NAP", "RAW_CODE", "IVAL_MMIO16", "IVAL_MMIO32", "IVAL_PHY",
  "IVAL_RADIO", "IVAL_SHM16", "IVAL_SHM32", "IVAL_TRAM", "$accept", "line",
  "line_terminator", "section_switch", "ivals_write", "statement",
  "asmdir", "asm_assert", "assertion", "assert_expr", "label", "insn_mul",
  "insn_add", "insn_addsc", "insn_addc", "insn_addscc", "insn_sub",
  "insn_subsc", "insn_subc", "insn_subscc", "insn_sra", "insn_or",
  "insn_and", "insn_xor", "insn_sr", "insn_srx", "insn_sl", "insn_rl",
  "insn_rr", "insn_nand", "insn_orx", "insn_mov", "insn_jmp", "insn_jand",
  "insn_jnand", "insn_js", "insn_jns", "insn_je", "insn_jne", "insn_jls",
  "insn_jges", "insn_jgs", "insn_jles", "insn_jl", "insn_jge", "insn_jg",
  "insn_jle", "insn_jzx", "insn_jnzx", "insn_jdn", "insn_jdpz", "insn_jdp",
  "insn_jdnz", "insn_jext", "insn_jnext", "linkreg", "insn_call",
  "insn_calls", "insn_ret", "insn_rets", "insn_tkiph", "insn_tkiphs",
  "insn_tkipl", "insn_tkipls", "insn_nap", "insn_raw", "raw_code",
  "extended_operlist", "external_jump_operands", "operlist_2",
  "operlist_3", "operand", "reg", "mem", "imm", "imm_value", "complex_imm",
  "complex_imm_oper", "complex_imm_arg", "complex_imm_const", "hexnum",
  "decnum", "hexnum_decnum", "labelref", "regnr", "identifier", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-162)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-156)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      12,    12,   254,  -162,  -162,  -162,  -162,     2,    60,    -3,
      25,  -162,     5,     5,     5,     5,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     5,    58,     5,     5,     5,
       5,    58,     5,    -3,     5,     5,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     5,     5,    58,    58,
      58,    58,     5,     5,     5,     5,    32,    -3,    32,  -162,
       5,     5,     5,     5,  -162,  -162,    58,    58,    58,    58,
      58,    58,    58,    12,    12,    12,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,     5,    -3,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,    71,  -162,  -162,    33,    33,    58,    35,  -162,
    -162,    44,  -162,  -162,  -162,  -162,  -162,  -162,  -162,   -13,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,    46,  -162,  -162,  -162,  -162,  -162,
    -162,    51,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
      55,  -162,  -162,  -162,  -162,  -162,    33,    63,  -162,    73,
    -162,  -162,  -162,  -162,    76,    79,    93,    99,   100,   101,
     102,  -162,  -162,  -162,  -162,    53,    50,    66,    98,    70,
    -162,  -162,  -162,    21,    58,   104,   105,    69,   106,  -162,
       5,  -162,  -162,    58,     5,    -3,  -162,    -3,    32,    58,
      58,    58,    58,    58,    58,    58,  -162,    47,    84,    25,
      25,  -162,    58,    58,   107,  -162,   108,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,    19,
    -162,   112,   114,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,   115,   116,  -162,   113,   117,  -162,  -162,    33,  -162,
      60,  -162,   118,  -162,     5,     5,    58,    58,  -162,  -162,
      68,  -162,  -162,   119,  -162,  -162,  -162,     5,   121,     5,
    -162
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       6,     6,     0,     2,     7,     1,     8,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   131,
       0,     0,     0,     0,   136,   138,     0,     0,     0,     0,
       0,     0,     0,     6,     6,     6,    17,    75,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    55,    56,    57,    58,    59,    60,    51,    52,    53,
      54,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,     0,     0,   174,   175,   176,   177,    73,
     182,    74,     0,    76,   149,     0,     0,     0,     0,   145,
      83,     0,   143,   144,   146,   153,   155,   154,   147,   178,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   125,
       0,   126,   121,   122,   123,   124,     0,     0,   129,     0,
     132,   133,   134,   135,     0,     0,     0,     0,     0,     0,
       0,     4,     5,     3,   137,     0,     0,     0,     0,     0,
     181,   148,   150,     0,     0,     0,   171,     0,   170,   172,
       0,   180,   179,     0,     0,     0,   127,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     9,   171,   172,     0,
       0,    77,     0,     0,     0,   151,     0,   173,   158,   157,
     161,   162,   163,   164,   165,   166,   167,   168,   169,     0,
     160,     0,     0,   141,   140,   128,   130,    10,    11,    12,
      13,     0,     0,    16,     0,     0,    80,    81,     0,   159,
       0,   171,     0,   170,     0,     0,     0,     0,    78,    79,
       0,   156,   142,     0,    14,    15,   152,     0,     0,     0,
     139
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -162,  -162,     7,  -162,  -162,  -162,  -162,   127,    -7,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,   -56,  -162,  -162,  -162,  -162,
    -162,  -162,  -162,  -162,  -162,  -162,   134,    -9,    65,    -1,
     131,   -31,  -162,  -162,   -39,   -22,  -142,  -162,  -161,  -160,
    -162,  -162,    -8,   -23,  -141,    -2
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     3,    73,    74,    75,    76,   235,   227,   228,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   207,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   149,   173,   199,   180,
     150,   151,   152,   153,   154,   155,   156,   279,   237,   238,
     137,   138,   157,   158,   231,   159
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     139,   181,   209,   143,   174,   232,   236,   141,     4,   174,
     182,   200,   200,   144,   145,   146,   241,   242,   134,   147,
     140,   148,   179,   135,   136,     1,   174,   174,   140,   181,
     181,   181,   181,   264,   208,   148,   265,   135,   136,   197,
     198,   142,    10,   206,   214,   215,   216,   217,   218,   219,
     220,   148,   230,   135,   136,   300,   240,    10,   243,   210,
     211,   212,   213,   244,   269,   246,   226,   245,   135,   136,
     256,   234,  -155,  -155,   148,   247,   135,   136,   135,   136,
     221,   222,   223,   316,   257,   248,   234,   226,   249,   135,
     136,   250,   266,   259,   260,   262,   263,    65,   270,   271,
     272,   273,   274,   275,   276,   251,   277,   278,   233,  -154,
    -154,   252,   253,   254,   255,   261,   201,   298,   302,   303,
     229,   268,   269,   280,   304,   299,   305,   306,   307,    77,
     308,   317,   225,   319,   309,   311,   133,   301,     0,     0,
     239,     0,     0,     0,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   310,   175,   176,
     177,   178,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,     0,
       0,     0,     0,   202,   203,   204,   205,     0,     0,     0,
       0,     0,   286,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   229,     0,     0,     0,     0,   281,
       0,     0,     0,   283,     0,     0,     0,     0,   258,     0,
       0,   282,   284,     0,   285,     0,   267,   287,   288,   289,
     290,   291,   292,   293,     0,     0,     0,     0,     0,     0,
     296,   297,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   294,   295,     5,     0,     0,     6,     7,     8,
       9,    10,     0,     0,   224,     0,     0,     0,     0,     0,
       0,   239,     0,   312,   313,     0,    11,     0,     0,     0,
       0,     0,     0,     0,   314,   315,   318,     0,   320,     0,
       0,     0,   267,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72
};

static const yytype_int16 yycheck[] =
{
       8,    32,    58,    10,    26,   146,   148,     9,     1,    31,
      33,    50,    51,     8,     9,    10,    29,    30,    16,    14,
      23,    16,    31,    18,    19,    13,    48,    49,    23,    60,
      61,    62,    63,    12,    57,    16,    15,    18,    19,    48,
      49,    16,     7,    11,    66,    67,    68,    69,    70,    71,
      72,    16,    19,    18,    19,    36,    12,     7,    12,    60,
      61,    62,    63,    12,    17,   206,    16,    12,    18,    19,
      17,    36,    25,    26,    16,    12,    18,    19,    18,    19,
      73,    74,    75,    15,   226,    12,    36,    16,    12,    18,
      19,    12,   234,    27,    28,    25,    26,    92,    29,    30,
      31,    32,    33,    34,    35,    12,    37,    38,   147,    25,
      26,    12,    12,    12,    12,    17,    51,    10,   279,   279,
     142,    17,    17,    17,    12,    17,    12,    12,    12,     2,
      17,    12,   134,    12,    17,    17,     2,   279,    -1,    -1,
     148,    -1,    -1,    -1,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,   298,    27,    28,
      29,    30,    -1,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    -1,   248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   226,    -1,    -1,    -1,    -1,   240,
      -1,    -1,    -1,   244,    -1,    -1,    -1,    -1,   226,    -1,
      -1,   243,   245,    -1,   247,    -1,   234,   249,   250,   251,
     252,   253,   254,   255,    -1,    -1,    -1,    -1,    -1,    -1,
     262,   263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   259,   260,     0,    -1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,
      -1,   279,    -1,   304,   305,    -1,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   306,   307,   317,    -1,   319,    -1,
      -1,    -1,   300,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    13,   101,   102,   102,     0,     3,     4,     5,     6,
       7,    22,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   103,   104,   105,   106,   107,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,    16,    18,    19,   180,   181,   182,
      23,   185,    16,   108,     8,     9,    10,    14,    16,   166,
     170,   171,   172,   173,   174,   175,   176,   182,   183,   185,
     170,   170,   170,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   170,   167,   175,   170,   170,   170,   170,   167,
     169,   171,   183,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   170,   170,   170,   170,   170,   167,   167,   168,
     174,   168,   170,   170,   170,   170,    11,   155,   183,   155,
     169,   169,   169,   169,   175,   175,   175,   175,   175,   175,
     175,   102,   102,   102,   170,   185,    16,   108,   109,   175,
      19,   184,   184,   174,    36,   107,   176,   178,   179,   182,
      12,    29,    30,    12,    12,    12,   184,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    17,   176,   182,    27,
      28,    17,    25,    26,    12,    15,   176,   182,    17,    17,
      29,    30,    31,    32,    33,    34,    35,    37,    38,   177,
      17,   171,   175,   171,   183,   183,   155,   175,   175,   175,
     175,   175,   175,   175,   108,   108,   175,   175,    10,    17,
      36,   176,   178,   179,    12,    12,    12,    12,    17,    17,
     184,    17,   171,   171,   175,   175,    15,    12,   171,    12,
     171
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   100,   101,   101,   101,   101,   102,   102,   103,   103,
     104,   104,   104,   104,   104,   104,   104,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   106,   106,   106,   107,   108,   108,   108,
     109,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   171,   171,   171,   171,   172,   172,
     172,   173,   173,   174,   175,   175,   176,   176,   176,   176,
     176,   177,   177,   177,   177,   177,   177,   177,   177,   177,
     178,   178,   179,   179,   180,   181,   182,   182,   183,   183,
     183,   184,   185
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     3,     3,     3,     0,     2,     1,     4,
       4,     4,     4,     4,     6,     6,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     1,     2,     3,     5,     5,
       3,     3,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,     2,
       4,     1,     2,     2,     2,     2,     1,     2,     1,     9,
       3,     3,     5,     1,     1,     1,     1,     1,     2,     1,
       2,     3,     6,     1,     1,     1,     5,     3,     3,     4,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       2,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* line: line_terminator  */
#line 54 "parser.y"
                          {
		/* empty */
	  }
#line 1547 "parser.c"
    break;

  case 3: /* line: line statement line_terminator  */
#line 57 "parser.y"
                                         {
		struct statement *s = yyvsp[-1];
		if (s) {
			if (section != SECTION_TEXT)
				yyerror("Microcode text instruction in non .text section");
			memcpy(&s->info, &cur_lineinfo, sizeof(struct lineinfo));
			list_add_tail(&s->list, &infile.sl);
		}
	  }
#line 1561 "parser.c"
    break;

  case 4: /* line: line section_switch line_terminator  */
#line 66 "parser.y"
                                              {
	  }
#line 1568 "parser.c"
    break;

  case 5: /* line: line ivals_write line_terminator  */
#line 68 "parser.y"
                                           {
		struct initval_op *io = yyvsp[-1];
		if (section != SECTION_IVALS)
			yyerror("InitVals write in non .initvals section");
		memcpy(&io->info, &cur_lineinfo, sizeof(struct lineinfo));
		INIT_LIST_HEAD(&io->list);
		list_add_tail(&io->list, &cur_initvals_sect->ops);
	  }
#line 1581 "parser.c"
    break;

  case 8: /* section_switch: SECTION_TEXT  */
#line 83 "parser.y"
                               {
			section = SECTION_TEXT;
		  }
#line 1589 "parser.c"
    break;

  case 9: /* section_switch: SECTION_IVALS PAREN_OPEN identifier PAREN_CLOSE  */
#line 86 "parser.y"
                                                                  {
			const char *sectname = yyvsp[-1];
			struct initvals_sect *s;
			cur_initvals_sect = NULL;
			/* Search if there already is a section by that name. */
			list_for_each_entry(s, &infile.ivals, list) {
				if (strcmp(sectname, s->name) == 0)
					cur_initvals_sect = s;
			}
			if (!cur_initvals_sect) {
				/* Not found, create a new one. */
				s = xmalloc(sizeof(struct initvals_sect));
				s->name = sectname;
				INIT_LIST_HEAD(&s->ops);
				INIT_LIST_HEAD(&s->list);
				list_add_tail(&s->list, &infile.ivals);
				cur_initvals_sect = s;
			}
			section = SECTION_IVALS;
		  }
#line 1614 "parser.c"
    break;

  case 10: /* ivals_write: IVAL_MMIO16 imm_value COMMA imm_value  */
#line 108 "parser.y"
                                                        {
			struct initval_op *iop = xmalloc(sizeof(struct initval_op));
			iop->type = IVAL_W_MMIO16;
			iop->args[0] = (unsigned int)(unsigned long)yyvsp[-2];
			iop->args[1] = (unsigned int)(unsigned long)yyvsp[0];
			yyval = iop;
		  }
#line 1626 "parser.c"
    break;

  case 11: /* ivals_write: IVAL_MMIO32 imm_value COMMA imm_value  */
#line 115 "parser.y"
                                                        {
			struct initval_op *iop = xmalloc(sizeof(struct initval_op));
			iop->type = IVAL_W_MMIO32;
			iop->args[0] = (unsigned int)(unsigned long)yyvsp[-2];
			iop->args[1] = (unsigned int)(unsigned long)yyvsp[0];
			yyval = iop;
		  }
#line 1638 "parser.c"
    break;

  case 12: /* ivals_write: IVAL_PHY imm_value COMMA imm_value  */
#line 122 "parser.y"
                                                     {
			struct initval_op *iop = xmalloc(sizeof(struct initval_op));
			iop->type = IVAL_W_PHY;
			iop->args[0] = (unsigned int)(unsigned long)yyvsp[-2];
			iop->args[1] = (unsigned int)(unsigned long)yyvsp[0];
			yyval = iop;
		  }
#line 1650 "parser.c"
    break;

  case 13: /* ivals_write: IVAL_RADIO imm_value COMMA imm_value  */
#line 129 "parser.y"
                                                       {
			struct initval_op *iop = xmalloc(sizeof(struct initval_op));
			iop->type = IVAL_W_RADIO;
			iop->args[0] = (unsigned int)(unsigned long)yyvsp[-2];
			iop->args[1] = (unsigned int)(unsigned long)yyvsp[0];
			yyval = iop;
		  }
#line 1662 "parser.c"
    break;

  case 14: /* ivals_write: IVAL_SHM16 imm_value COMMA imm_value COMMA imm_value  */
#line 136 "parser.y"
                                                                       {
			struct initval_op *iop = xmalloc(sizeof(struct initval_op));
			iop->type = IVAL_W_SHM16;
			iop->args[0] = (unsigned int)(unsigned long)yyvsp[-4];
			iop->args[1] = (unsigned int)(unsigned long)yyvsp[-2];
			iop->args[2] = (unsigned int)(unsigned long)yyvsp[0];
			yyval = iop;
		  }
#line 1675 "parser.c"
    break;

  case 15: /* ivals_write: IVAL_SHM32 imm_value COMMA imm_value COMMA imm_value  */
#line 144 "parser.y"
                                                                       {
			struct initval_op *iop = xmalloc(sizeof(struct initval_op));
			iop->type = IVAL_W_SHM32;
			iop->args[0] = (unsigned int)(unsigned long)yyvsp[-4];
			iop->args[1] = (unsigned int)(unsigned long)yyvsp[-2];
			iop->args[2] = (unsigned int)(unsigned long)yyvsp[0];
			yyval = iop;
		  }
#line 1688 "parser.c"
    break;

  case 16: /* ivals_write: IVAL_TRAM imm_value COMMA imm_value  */
#line 152 "parser.y"
                                                      {
			struct initval_op *iop = xmalloc(sizeof(struct initval_op));
			iop->type = IVAL_W_TRAM;
			iop->args[0] = (unsigned int)(unsigned long)yyvsp[-2];
			iop->args[1] = (unsigned int)(unsigned long)yyvsp[0];
			yyval = iop;
		  }
#line 1700 "parser.c"
    break;

  case 17: /* statement: asmdir  */
#line 161 "parser.y"
                         {
			struct asmdir *ad = yyvsp[0];
			if (ad) {
				struct statement *s = xmalloc(sizeof(struct statement));
				INIT_LIST_HEAD(&s->list);
				s->type = STMT_ASMDIR;
				s->u.asmdir = yyvsp[0];
				yyval = s;
			} else
				yyval = NULL;
		  }
#line 1716 "parser.c"
    break;

  case 18: /* statement: label  */
#line 172 "parser.y"
                        {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_LABEL;
			s->u.label = yyvsp[0];
			yyval = s;
		  }
#line 1728 "parser.c"
    break;

  case 19: /* statement: insn_mul  */
#line 179 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1740 "parser.c"
    break;

  case 20: /* statement: insn_add  */
#line 186 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1752 "parser.c"
    break;

  case 21: /* statement: insn_addsc  */
#line 193 "parser.y"
                             {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1764 "parser.c"
    break;

  case 22: /* statement: insn_addc  */
#line 200 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1776 "parser.c"
    break;

  case 23: /* statement: insn_addscc  */
#line 207 "parser.y"
                              {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1788 "parser.c"
    break;

  case 24: /* statement: insn_sub  */
#line 214 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1800 "parser.c"
    break;

  case 25: /* statement: insn_subsc  */
#line 221 "parser.y"
                             {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1812 "parser.c"
    break;

  case 26: /* statement: insn_subc  */
#line 228 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1824 "parser.c"
    break;

  case 27: /* statement: insn_subscc  */
#line 235 "parser.y"
                              {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1836 "parser.c"
    break;

  case 28: /* statement: insn_sra  */
#line 242 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1848 "parser.c"
    break;

  case 29: /* statement: insn_or  */
#line 249 "parser.y"
                          {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1860 "parser.c"
    break;

  case 30: /* statement: insn_and  */
#line 256 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1872 "parser.c"
    break;

  case 31: /* statement: insn_xor  */
#line 263 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1884 "parser.c"
    break;

  case 32: /* statement: insn_sr  */
#line 270 "parser.y"
                          {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1896 "parser.c"
    break;

  case 33: /* statement: insn_srx  */
#line 277 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1908 "parser.c"
    break;

  case 34: /* statement: insn_sl  */
#line 284 "parser.y"
                          {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1920 "parser.c"
    break;

  case 35: /* statement: insn_rl  */
#line 291 "parser.y"
                          {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1932 "parser.c"
    break;

  case 36: /* statement: insn_rr  */
#line 298 "parser.y"
                          {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1944 "parser.c"
    break;

  case 37: /* statement: insn_nand  */
#line 305 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1956 "parser.c"
    break;

  case 38: /* statement: insn_orx  */
#line 312 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1968 "parser.c"
    break;

  case 39: /* statement: insn_mov  */
#line 319 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1980 "parser.c"
    break;

  case 40: /* statement: insn_jmp  */
#line 326 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 1992 "parser.c"
    break;

  case 41: /* statement: insn_jand  */
#line 333 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2004 "parser.c"
    break;

  case 42: /* statement: insn_jnand  */
#line 340 "parser.y"
                             {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2016 "parser.c"
    break;

  case 43: /* statement: insn_js  */
#line 347 "parser.y"
                          {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2028 "parser.c"
    break;

  case 44: /* statement: insn_jns  */
#line 354 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2040 "parser.c"
    break;

  case 45: /* statement: insn_je  */
#line 361 "parser.y"
                          {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2052 "parser.c"
    break;

  case 46: /* statement: insn_jne  */
#line 368 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2064 "parser.c"
    break;

  case 47: /* statement: insn_jls  */
#line 375 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2076 "parser.c"
    break;

  case 48: /* statement: insn_jges  */
#line 382 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2088 "parser.c"
    break;

  case 49: /* statement: insn_jgs  */
#line 389 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2100 "parser.c"
    break;

  case 50: /* statement: insn_jles  */
#line 396 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2112 "parser.c"
    break;

  case 51: /* statement: insn_jdn  */
#line 403 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2124 "parser.c"
    break;

  case 52: /* statement: insn_jdpz  */
#line 410 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2136 "parser.c"
    break;

  case 53: /* statement: insn_jdp  */
#line 417 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2148 "parser.c"
    break;

  case 54: /* statement: insn_jdnz  */
#line 424 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2160 "parser.c"
    break;

  case 55: /* statement: insn_jl  */
#line 431 "parser.y"
                          {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2172 "parser.c"
    break;

  case 56: /* statement: insn_jge  */
#line 438 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2184 "parser.c"
    break;

  case 57: /* statement: insn_jg  */
#line 445 "parser.y"
                          {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2196 "parser.c"
    break;

  case 58: /* statement: insn_jle  */
#line 452 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2208 "parser.c"
    break;

  case 59: /* statement: insn_jzx  */
#line 459 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2220 "parser.c"
    break;

  case 60: /* statement: insn_jnzx  */
#line 466 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2232 "parser.c"
    break;

  case 61: /* statement: insn_jext  */
#line 473 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2244 "parser.c"
    break;

  case 62: /* statement: insn_jnext  */
#line 480 "parser.y"
                             {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2256 "parser.c"
    break;

  case 63: /* statement: insn_call  */
#line 487 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2268 "parser.c"
    break;

  case 64: /* statement: insn_calls  */
#line 494 "parser.y"
                             {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2280 "parser.c"
    break;

  case 65: /* statement: insn_ret  */
#line 501 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2292 "parser.c"
    break;

  case 66: /* statement: insn_rets  */
#line 508 "parser.y"
                            {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2304 "parser.c"
    break;

  case 67: /* statement: insn_tkiph  */
#line 515 "parser.y"
                             {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2316 "parser.c"
    break;

  case 68: /* statement: insn_tkiphs  */
#line 522 "parser.y"
                              {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2328 "parser.c"
    break;

  case 69: /* statement: insn_tkipl  */
#line 529 "parser.y"
                             {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2340 "parser.c"
    break;

  case 70: /* statement: insn_tkipls  */
#line 536 "parser.y"
                              {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2352 "parser.c"
    break;

  case 71: /* statement: insn_nap  */
#line 543 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2364 "parser.c"
    break;

  case 72: /* statement: insn_raw  */
#line 550 "parser.y"
                           {
			struct statement *s = xmalloc(sizeof(struct statement));
			INIT_LIST_HEAD(&s->list);
			s->type = STMT_INSN;
			s->u.insn = yyvsp[0];
			yyval = s;
		  }
#line 2376 "parser.c"
    break;

  case 73: /* asmdir: ASM_ARCH hexnum_decnum  */
#line 560 "parser.y"
                                         {
			struct asmdir *ad = xmalloc(sizeof(struct asmdir));
			ad->type = ADIR_ARCH;
			ad->u.arch = (unsigned int)(unsigned long)yyvsp[0];
			yyval = ad;
		  }
#line 2387 "parser.c"
    break;

  case 74: /* asmdir: ASM_START identifier  */
#line 566 "parser.y"
                                       {
			struct asmdir *ad = xmalloc(sizeof(struct asmdir));
			struct label *label = xmalloc(sizeof(struct label));
			label->name = yyvsp[0];
			label->direction = LABELREF_ABSOLUTE;
			ad->type = ADIR_START;
			ad->u.start = label;
			yyval = ad;
		  }
#line 2401 "parser.c"
    break;

  case 75: /* asmdir: asm_assert  */
#line 575 "parser.y"
                             {
			yyval = NULL;
		  }
#line 2409 "parser.c"
    break;

  case 76: /* asm_assert: ASM_ASSERT assertion  */
#line 580 "parser.y"
                                       {
			unsigned int ok = (unsigned int)(unsigned long)yyvsp[0];
			if (!ok)
				assembler_assertion_failed();
			yyval = NULL;
		  }
#line 2420 "parser.c"
    break;

  case 77: /* assertion: PAREN_OPEN assert_expr PAREN_CLOSE  */
#line 588 "parser.y"
                                                     {
			yyval = yyvsp[-1];
		  }
#line 2428 "parser.c"
    break;

  case 78: /* assertion: PAREN_OPEN assertion LOGICAL_OR assertion PAREN_CLOSE  */
#line 591 "parser.y"
                                                                        {
			unsigned int a = (unsigned int)(unsigned long)yyvsp[-3];
			unsigned int b = (unsigned int)(unsigned long)yyvsp[-1];
			unsigned int result = (a || b);
			yyval = (void *)(unsigned long)result;
		  }
#line 2439 "parser.c"
    break;

  case 79: /* assertion: PAREN_OPEN assertion LOGICAL_AND assertion PAREN_CLOSE  */
#line 597 "parser.y"
                                                                         {
			unsigned int a = (unsigned int)(unsigned long)yyvsp[-3];
			unsigned int b = (unsigned int)(unsigned long)yyvsp[-1];
			unsigned int result = (a && b);
			yyval = (void *)(unsigned long)result;
		  }
#line 2450 "parser.c"
    break;

  case 80: /* assert_expr: imm_value EQUAL imm_value  */
#line 605 "parser.y"
                                            {
			unsigned int a = (unsigned int)(unsigned long)yyvsp[-2];
			unsigned int b = (unsigned int)(unsigned long)yyvsp[0];
			unsigned int result = (a == b);
			yyval = (void *)(unsigned long)result;
		  }
#line 2461 "parser.c"
    break;

  case 81: /* assert_expr: imm_value NOT_EQUAL imm_value  */
#line 611 "parser.y"
                                                {
			unsigned int a = (unsigned int)(unsigned long)yyvsp[-2];
			unsigned int b = (unsigned int)(unsigned long)yyvsp[0];
			unsigned int result = (a != b);
			yyval = (void *)(unsigned long)result;
		  }
#line 2472 "parser.c"
    break;

  case 82: /* label: LABEL  */
#line 619 "parser.y"
                        {
			struct label *label = xmalloc(sizeof(struct label));
			char *l;
			l = xstrdup(yytext);
			l[strlen(l) - 1] = '\0';
			label->name = l;
			yyval = label;
		  }
#line 2485 "parser.c"
    break;

  case 83: /* insn_mul: OP_MUL operlist_3  */
#line 630 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_MUL;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2496 "parser.c"
    break;

  case 84: /* insn_add: OP_ADD operlist_3  */
#line 639 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_ADD;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2507 "parser.c"
    break;

  case 85: /* insn_addsc: OP_ADDSC operlist_3  */
#line 648 "parser.y"
                                      {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_ADDSC;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2518 "parser.c"
    break;

  case 86: /* insn_addc: OP_ADDC operlist_3  */
#line 657 "parser.y"
                                     {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_ADDC;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2529 "parser.c"
    break;

  case 87: /* insn_addscc: OP_ADDSCC operlist_3  */
#line 666 "parser.y"
                                       {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_ADDSCC;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2540 "parser.c"
    break;

  case 88: /* insn_sub: OP_SUB operlist_3  */
#line 675 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_SUB;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2551 "parser.c"
    break;

  case 89: /* insn_subsc: OP_SUBSC operlist_3  */
#line 684 "parser.y"
                                      {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_SUBSC;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2562 "parser.c"
    break;

  case 90: /* insn_subc: OP_SUBC operlist_3  */
#line 693 "parser.y"
                                     {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_SUBC;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2573 "parser.c"
    break;

  case 91: /* insn_subscc: OP_SUBSCC operlist_3  */
#line 702 "parser.y"
                                       {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_SUBSCC;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2584 "parser.c"
    break;

  case 92: /* insn_sra: OP_SRA operlist_3  */
#line 710 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_SRA;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2595 "parser.c"
    break;

  case 93: /* insn_or: OP_OR operlist_3  */
#line 718 "parser.y"
                                   {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_OR;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2606 "parser.c"
    break;

  case 94: /* insn_and: OP_AND operlist_3  */
#line 726 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_AND;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2617 "parser.c"
    break;

  case 95: /* insn_xor: OP_XOR operlist_3  */
#line 734 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_XOR;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2628 "parser.c"
    break;

  case 96: /* insn_sr: OP_SR operlist_3  */
#line 742 "parser.y"
                                   {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_SR;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2639 "parser.c"
    break;

  case 97: /* insn_srx: OP_SRX extended_operlist  */
#line 750 "parser.y"
                                           {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_SRX;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2650 "parser.c"
    break;

  case 98: /* insn_sl: OP_SL operlist_3  */
#line 758 "parser.y"
                                   {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_SL;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2661 "parser.c"
    break;

  case 99: /* insn_rl: OP_RL operlist_3  */
#line 766 "parser.y"
                                   {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_RL;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2672 "parser.c"
    break;

  case 100: /* insn_rr: OP_RR operlist_3  */
#line 774 "parser.y"
                                   {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_RR;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2683 "parser.c"
    break;

  case 101: /* insn_nand: OP_NAND operlist_3  */
#line 782 "parser.y"
                                     {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_NAND;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2694 "parser.c"
    break;

  case 102: /* insn_orx: OP_ORX extended_operlist  */
#line 790 "parser.y"
                                           {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_ORX;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2705 "parser.c"
    break;

  case 103: /* insn_mov: OP_MOV operlist_2  */
#line 798 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_MOV;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2716 "parser.c"
    break;

  case 104: /* insn_jmp: OP_JMP labelref  */
#line 806 "parser.y"
                                  {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			struct operlist *ol = xmalloc(sizeof(struct operlist));
			ol->oper[0] = yyvsp[0];
			insn->op = OP_JMP;
			insn->operands = ol;
			yyval = insn;
		  }
#line 2729 "parser.c"
    break;

  case 105: /* insn_jand: OP_JAND operlist_3  */
#line 816 "parser.y"
                                     {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JAND;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2740 "parser.c"
    break;

  case 106: /* insn_jnand: OP_JNAND operlist_3  */
#line 824 "parser.y"
                                      {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JNAND;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2751 "parser.c"
    break;

  case 107: /* insn_js: OP_JS operlist_3  */
#line 832 "parser.y"
                                   {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JS;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2762 "parser.c"
    break;

  case 108: /* insn_jns: OP_JNS operlist_3  */
#line 840 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JNS;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2773 "parser.c"
    break;

  case 109: /* insn_je: OP_JE operlist_3  */
#line 848 "parser.y"
                                   {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JE;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2784 "parser.c"
    break;

  case 110: /* insn_jne: OP_JNE operlist_3  */
#line 856 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JNE;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2795 "parser.c"
    break;

  case 111: /* insn_jls: OP_JLS operlist_3  */
#line 864 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JLS;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2806 "parser.c"
    break;

  case 112: /* insn_jges: OP_JGES operlist_3  */
#line 872 "parser.y"
                                     {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JGES;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2817 "parser.c"
    break;

  case 113: /* insn_jgs: OP_JGS operlist_3  */
#line 880 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JGS;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2828 "parser.c"
    break;

  case 114: /* insn_jles: OP_JLES operlist_3  */
#line 888 "parser.y"
                                     {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JLES;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2839 "parser.c"
    break;

  case 115: /* insn_jl: OP_JL operlist_3  */
#line 896 "parser.y"
                                   {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JL;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2850 "parser.c"
    break;

  case 116: /* insn_jge: OP_JGE operlist_3  */
#line 904 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JGE;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2861 "parser.c"
    break;

  case 117: /* insn_jg: OP_JG operlist_3  */
#line 912 "parser.y"
                                   {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JG;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2872 "parser.c"
    break;

  case 118: /* insn_jle: OP_JLE operlist_3  */
#line 920 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JLE;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2883 "parser.c"
    break;

  case 119: /* insn_jzx: OP_JZX extended_operlist  */
#line 928 "parser.y"
                                           {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JZX;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2894 "parser.c"
    break;

  case 120: /* insn_jnzx: OP_JNZX extended_operlist  */
#line 936 "parser.y"
                                            {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JNZX;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2905 "parser.c"
    break;

  case 121: /* insn_jdn: OP_JDN operlist_3  */
#line 944 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JDN;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2916 "parser.c"
    break;

  case 122: /* insn_jdpz: OP_JDPZ operlist_3  */
#line 952 "parser.y"
                                     {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JDPZ;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2927 "parser.c"
    break;

  case 123: /* insn_jdp: OP_JDP operlist_3  */
#line 960 "parser.y"
                                    {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JDP;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2938 "parser.c"
    break;

  case 124: /* insn_jdnz: OP_JDNZ operlist_3  */
#line 968 "parser.y"
                                     {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JDNZ;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2949 "parser.c"
    break;

  case 125: /* insn_jext: OP_JEXT external_jump_operands  */
#line 976 "parser.y"
                                                 {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JEXT;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2960 "parser.c"
    break;

  case 126: /* insn_jnext: OP_JNEXT external_jump_operands  */
#line 984 "parser.y"
                                                  {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = OP_JNEXT;
			insn->operands = yyvsp[0];
			yyval = insn;
		  }
#line 2971 "parser.c"
    break;

  case 127: /* linkreg: LR regnr  */
#line 992 "parser.y"
                           {
			yyval = yyvsp[0];
		  }
#line 2979 "parser.c"
    break;

  case 128: /* insn_call: OP_CALL linkreg COMMA labelref  */
#line 997 "parser.y"
                                                 {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			struct operlist *ol = xmalloc(sizeof(struct operlist));
			struct operand *oper_lr = xmalloc(sizeof(struct operand));
			struct operand *oper_zero = xmalloc(sizeof(struct operand));
			oper_zero->type = OPER_RAW;
			oper_zero->u.raw = 0;
			oper_lr->type = OPER_RAW;
			oper_lr->u.raw = (unsigned long)yyvsp[-2];
			ol->oper[0] = oper_lr;
			ol->oper[1] = oper_zero;
			ol->oper[2] = yyvsp[0];
			insn->op = OP_CALL;
			insn->operands = ol;
			yyval = insn;
		  }
#line 3000 "parser.c"
    break;

  case 129: /* insn_calls: OP_CALLS labelref  */
#line 1015 "parser.y"
                                     {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			struct operlist *ol = xmalloc(sizeof(struct operlist));
			struct operand *oper_r0 = xmalloc(sizeof(struct operand));
			struct registr *r0 = xmalloc(sizeof(struct registr));
			r0->type = GPR;
			r0->nr = 0;
			oper_r0->type = OPER_REG;
			oper_r0->u.reg = r0;
			ol->oper[0] = oper_r0;
			ol->oper[1] = oper_r0;
			ol->oper[2] = yyvsp[0];
			insn->op = OP_CALLS;
			insn->operands = ol;
			yyval = insn;
		  }
#line 3021 "parser.c"
    break;

  case 130: /* insn_ret: OP_RET linkreg COMMA linkreg  */
#line 1033 "parser.y"
                                               {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			struct operlist *ol = xmalloc(sizeof(struct operlist));
			struct operand *oper_lr0 = xmalloc(sizeof(struct operand));
			struct operand *oper_lr1 = xmalloc(sizeof(struct operand));
			struct operand *oper_zero = xmalloc(sizeof(struct operand));
			oper_zero->type = OPER_RAW;
			oper_zero->u.raw = 0;
			oper_lr0->type = OPER_RAW;
			oper_lr0->u.raw = (unsigned long)yyvsp[-2];
			oper_lr1->type = OPER_RAW;
			oper_lr1->u.raw = (unsigned long)yyvsp[0];
			ol->oper[0] = oper_lr0;
			ol->oper[1] = oper_zero;
			ol->oper[2] = oper_lr1;
			insn->op = OP_RET;
			insn->operands = ol;
			yyval = insn;
		  }
#line 3045 "parser.c"
    break;

  case 131: /* insn_rets: OP_RETS  */
#line 1054 "parser.y"
                          {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			struct operlist *ol = xmalloc(sizeof(struct operlist));
			struct operand *oper_r0 = xmalloc(sizeof(struct operand));
			struct operand *oper_zero = xmalloc(sizeof(struct operand));
			struct registr *r0 = xmalloc(sizeof(struct registr));
			oper_zero->type = OPER_RAW;
			oper_zero->u.raw = 0;
			r0->type = GPR;
			r0->nr = 0;
			oper_r0->type = OPER_REG;
			oper_r0->u.reg = r0;
			ol->oper[0] = oper_r0;
			ol->oper[1] = oper_r0;
			ol->oper[2] = oper_zero;
			insn->op = OP_RETS;
			insn->operands = ol;
			yyval = insn;
		  }
#line 3069 "parser.c"
    break;

  case 132: /* insn_tkiph: OP_TKIPH operlist_2  */
#line 1075 "parser.y"
                                      {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			struct operlist *ol = yyvsp[0];
			struct operand *flags = xmalloc(sizeof(struct operand));
			struct immediate *imm = xmalloc(sizeof(struct immediate));
			imm->imm = 0x1;
			flags->type = OPER_IMM;
			flags->u.imm = imm;
			ol->oper[2] = ol->oper[1];
			ol->oper[1] = flags;
			insn->op = OP_TKIPH;
			insn->operands = ol;
			yyval = insn;
		  }
#line 3088 "parser.c"
    break;

  case 133: /* insn_tkiphs: OP_TKIPHS operlist_2  */
#line 1091 "parser.y"
                                       {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			struct operlist *ol = yyvsp[0];
			struct operand *flags = xmalloc(sizeof(struct operand));
			struct immediate *imm = xmalloc(sizeof(struct immediate));
			imm->imm = 0x1 | 0x2;
			flags->type = OPER_IMM;
			flags->u.imm = imm;
			ol->oper[2] = ol->oper[1];
			ol->oper[1] = flags;
			insn->op = OP_TKIPH;
			insn->operands = ol;
			yyval = insn;
		  }
#line 3107 "parser.c"
    break;

  case 134: /* insn_tkipl: OP_TKIPL operlist_2  */
#line 1107 "parser.y"
                                      {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			struct operlist *ol = yyvsp[0];
			struct operand *flags = xmalloc(sizeof(struct operand));
			struct immediate *imm = xmalloc(sizeof(struct immediate));
			imm->imm = 0x0;
			flags->type = OPER_IMM;
			flags->u.imm = imm;
			ol->oper[2] = ol->oper[1];
			ol->oper[1] = flags;
			insn->op = OP_TKIPH;
			insn->operands = ol;
			yyval = insn;
		  }
#line 3126 "parser.c"
    break;

  case 135: /* insn_tkipls: OP_TKIPLS operlist_2  */
#line 1123 "parser.y"
                                       {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			struct operlist *ol = yyvsp[0];
			struct operand *flags = xmalloc(sizeof(struct operand));
			struct immediate *imm = xmalloc(sizeof(struct immediate));
			imm->imm = 0x0 | 0x2;
			flags->type = OPER_IMM;
			flags->u.imm = imm;
			ol->oper[2] = ol->oper[1];
			ol->oper[1] = flags;
			insn->op = OP_TKIPH;
			insn->operands = ol;
			yyval = insn;
		  }
#line 3145 "parser.c"
    break;

  case 136: /* insn_nap: OP_NAP  */
#line 1139 "parser.y"
                         {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			struct operlist *ol = xmalloc(sizeof(struct operlist));
			struct operand *regop = xmalloc(sizeof(struct operand));
			struct operand *zeroop = xmalloc(sizeof(struct operand));
			struct registr *r0 = xmalloc(sizeof(struct registr));
			r0->type = GPR;
			r0->nr = 0;
			regop->type = OPER_REG;
			regop->u.reg = r0;
			zeroop->type = OPER_RAW;
			zeroop->u.raw = 0x000;
			ol->oper[0] = regop;
			ol->oper[1] = regop;
			ol->oper[2] = zeroop;
			insn->op = OP_NAP;
			insn->operands = ol;
			yyval = insn;
		  }
#line 3169 "parser.c"
    break;

  case 137: /* insn_raw: raw_code operlist_3  */
#line 1160 "parser.y"
                                      {
			struct instruction *insn = xmalloc(sizeof(struct instruction));
			insn->op = RAW_CODE;
			insn->operands = yyvsp[0];
			insn->opcode = (unsigned long)yyvsp[-1];
			yyval = insn;
		  }
#line 3181 "parser.c"
    break;

  case 138: /* raw_code: RAW_CODE  */
#line 1169 "parser.y"
                           {
			yytext++; /* skip @ */
			yyval = (void *)(unsigned long)strtoul(yytext, NULL, 16);
		  }
#line 3190 "parser.c"
    break;

  case 139: /* extended_operlist: imm_value COMMA imm_value COMMA operand COMMA operand COMMA operand  */
#line 1175 "parser.y"
                                                                                        {
			struct operlist *ol = xmalloc(sizeof(struct operlist));
			struct operand *mask_oper = xmalloc(sizeof(struct operand));
			struct operand *shift_oper = xmalloc(sizeof(struct operand));
			mask_oper->type = OPER_RAW;
			mask_oper->u.raw = (unsigned long)yyvsp[-8];
			shift_oper->type = OPER_RAW;
			shift_oper->u.raw = (unsigned long)yyvsp[-6];
			ol->oper[0] = mask_oper;
			ol->oper[1] = shift_oper;
			ol->oper[2] = yyvsp[-4];
			ol->oper[3] = yyvsp[-2];
			ol->oper[4] = store_oper_sanity(yyvsp[0]);
			yyval = ol;
		  }
#line 3210 "parser.c"
    break;

  case 140: /* external_jump_operands: imm COMMA labelref  */
#line 1192 "parser.y"
                                            {
			struct operlist *ol = xmalloc(sizeof(struct operlist));
			struct operand *cond = xmalloc(sizeof(struct operand));
			cond->type = OPER_IMM;
			cond->u.imm = yyvsp[-2];
			ol->oper[0] = cond;
			ol->oper[1] = yyvsp[0];
			yyval = ol;
		  }
#line 3224 "parser.c"
    break;

  case 141: /* operlist_2: operand COMMA operand  */
#line 1203 "parser.y"
                                        {
			struct operlist *ol = xmalloc(sizeof(struct operlist));
			ol->oper[0] = yyvsp[-2];
			ol->oper[1] = store_oper_sanity(yyvsp[0]);
			yyval = ol;
		  }
#line 3235 "parser.c"
    break;

  case 142: /* operlist_3: operand COMMA operand COMMA operand  */
#line 1211 "parser.y"
                                                      {
			struct operlist *ol = xmalloc(sizeof(struct operlist));
			ol->oper[0] = yyvsp[-4];
			ol->oper[1] = yyvsp[-2];
			ol->oper[2] = store_oper_sanity(yyvsp[0]);
			yyval = ol;
		  }
#line 3247 "parser.c"
    break;

  case 143: /* operand: reg  */
#line 1220 "parser.y"
                      {
			struct operand *oper = xmalloc(sizeof(struct operand));
			oper->type = OPER_REG;
			oper->u.reg = yyvsp[0];
			yyval = oper;
		  }
#line 3258 "parser.c"
    break;

  case 144: /* operand: mem  */
#line 1226 "parser.y"
                      {
			struct operand *oper = xmalloc(sizeof(struct operand));
			oper->type = OPER_MEM;
			oper->u.mem = yyvsp[0];
			yyval = oper;
		  }
#line 3269 "parser.c"
    break;

  case 145: /* operand: raw_code  */
#line 1232 "parser.y"
                           {
			struct operand *oper = xmalloc(sizeof(struct operand));
			oper->type = OPER_RAW;
			oper->u.raw = (unsigned long)yyvsp[0];
			yyval = oper;
		  }
#line 3280 "parser.c"
    break;

  case 146: /* operand: imm  */
#line 1238 "parser.y"
                      {
			struct operand *oper = xmalloc(sizeof(struct operand));
			oper->type = OPER_IMM;
			oper->u.imm = yyvsp[0];
			yyval = oper;
		  }
#line 3291 "parser.c"
    break;

  case 147: /* operand: labelref  */
#line 1244 "parser.y"
                           {
			yyval = yyvsp[0];
		  }
#line 3299 "parser.c"
    break;

  case 148: /* reg: GPR regnr  */
#line 1249 "parser.y"
                            {
			struct registr *reg = xmalloc(sizeof(struct registr));
			reg->type = GPR;
			reg->nr = (unsigned long)yyvsp[0];
			yyval = reg;
		  }
#line 3310 "parser.c"
    break;

  case 149: /* reg: SPR  */
#line 1255 "parser.y"
                      {
			struct registr *reg = xmalloc(sizeof(struct registr));
			reg->type = SPR;
			yytext += 3; /* skip "spr" */
			reg->nr = strtoul(yytext, NULL, 16);
			yyval = reg;
		  }
#line 3322 "parser.c"
    break;

  case 150: /* reg: OFFR regnr  */
#line 1262 "parser.y"
                             {
			struct registr *reg = xmalloc(sizeof(struct registr));
			reg->type = OFFR;
			reg->nr = (unsigned long)yyvsp[0];
			yyval = reg;
		  }
#line 3333 "parser.c"
    break;

  case 151: /* mem: BRACK_OPEN imm BRACK_CLOSE  */
#line 1270 "parser.y"
                                             {
			struct memory *mem = xmalloc(sizeof(struct memory));
			struct immediate *offset_imm = yyvsp[-1];
			mem->type = MEM_DIRECT;
			mem->offset = offset_imm->imm;
			free(offset_imm);
			yyval = mem;
		  }
#line 3346 "parser.c"
    break;

  case 152: /* mem: BRACK_OPEN imm COMMA OFFR regnr BRACK_CLOSE  */
#line 1278 "parser.y"
                                                              {
			struct memory *mem = xmalloc(sizeof(struct memory));
			struct immediate *offset_imm = yyvsp[-4];
			mem->type = MEM_INDIRECT;
			mem->offset = offset_imm->imm;
			free(offset_imm);
			mem->offr_nr = (unsigned long)yyvsp[-1];
			yyval = mem;
		  }
#line 3360 "parser.c"
    break;

  case 153: /* imm: imm_value  */
#line 1289 "parser.y"
                            {
			struct immediate *imm = xmalloc(sizeof(struct immediate));
			imm->imm = (unsigned long)yyvsp[0];
			yyval = imm;
		  }
#line 3370 "parser.c"
    break;

  case 154: /* imm_value: hexnum_decnum  */
#line 1296 "parser.y"
                                {
			yyval = yyvsp[0];
		  }
#line 3378 "parser.c"
    break;

  case 155: /* imm_value: complex_imm  */
#line 1299 "parser.y"
                              {
			yyval = yyvsp[0];
		  }
#line 3386 "parser.c"
    break;

  case 156: /* complex_imm: PAREN_OPEN complex_imm_arg complex_imm_oper complex_imm_arg PAREN_CLOSE  */
#line 1304 "parser.y"
                                                                                          {
			unsigned long a = (unsigned long)yyvsp[-3];
			unsigned long b = (unsigned long)yyvsp[-1];
			unsigned long operation = (unsigned long)yyvsp[-2];
			unsigned long res = 31337;
			switch (operation) {
			case PLUS:
				res = a + b;
				break;
			case MINUS:
				res = a - b;
				break;
			case MULTIPLY:
				res = a * b;
				break;
			case DIVIDE:
				res = a / b;
				break;
			case BITW_OR:
				res = a | b;
				break;
			case BITW_AND:
				res = a & b;
				break;
			case BITW_XOR:
				res = a ^ b;
				break;
			case LEFTSHIFT:
				res = a << b;
				break;
			case RIGHTSHIFT:
				res = a >> b;
				break;
			default:
				yyerror("Internal parser BUG. complex_imm oper unknown");
			}
			yyval = (void *)res;
		  }
#line 3429 "parser.c"
    break;

  case 157: /* complex_imm: PAREN_OPEN complex_imm PAREN_CLOSE  */
#line 1342 "parser.y"
                                                     {
			yyval = yyvsp[-1];
		  }
#line 3437 "parser.c"
    break;

  case 158: /* complex_imm: PAREN_OPEN asm_assert PAREN_CLOSE  */
#line 1345 "parser.y"
                                                    {
			/* Inline assertion. Always return zero */
			yyval = (void *)(unsigned long)(unsigned int)0;
		  }
#line 3446 "parser.c"
    break;

  case 159: /* complex_imm: PAREN_OPEN BITW_NOT complex_imm PAREN_CLOSE  */
#line 1349 "parser.y"
                                                              {
			unsigned long n = (unsigned long)yyvsp[-1];
			n = ~n;
			yyval = (void *)n;
		  }
#line 3456 "parser.c"
    break;

  case 160: /* complex_imm: PAREN_OPEN complex_imm_const PAREN_CLOSE  */
#line 1354 "parser.y"
                                                           {
			yyval = yyvsp[-1];
		  }
#line 3464 "parser.c"
    break;

  case 161: /* complex_imm_oper: PLUS  */
#line 1359 "parser.y"
                        {
			yyval = (void *)(unsigned long)PLUS;
		  }
#line 3472 "parser.c"
    break;

  case 162: /* complex_imm_oper: MINUS  */
#line 1362 "parser.y"
                        {
			yyval = (void *)(unsigned long)MINUS;
		  }
#line 3480 "parser.c"
    break;

  case 163: /* complex_imm_oper: MULTIPLY  */
#line 1365 "parser.y"
                           {
			yyval = (void *)(unsigned long)MULTIPLY;
		  }
#line 3488 "parser.c"
    break;

  case 164: /* complex_imm_oper: DIVIDE  */
#line 1368 "parser.y"
                         {
			yyval = (void *)(unsigned long)DIVIDE;
		  }
#line 3496 "parser.c"
    break;

  case 165: /* complex_imm_oper: BITW_OR  */
#line 1371 "parser.y"
                          {
			yyval = (void *)(unsigned long)BITW_OR;
		  }
#line 3504 "parser.c"
    break;

  case 166: /* complex_imm_oper: BITW_AND  */
#line 1374 "parser.y"
                           {
			yyval = (void *)(unsigned long)BITW_AND;
		  }
#line 3512 "parser.c"
    break;

  case 167: /* complex_imm_oper: BITW_XOR  */
#line 1377 "parser.y"
                           {
			yyval = (void *)(unsigned long)BITW_XOR;
		  }
#line 3520 "parser.c"
    break;

  case 168: /* complex_imm_oper: LEFTSHIFT  */
#line 1380 "parser.y"
                            {
			yyval = (void *)(unsigned long)LEFTSHIFT;
		  }
#line 3528 "parser.c"
    break;

  case 169: /* complex_imm_oper: RIGHTSHIFT  */
#line 1383 "parser.y"
                             {
			yyval = (void *)(unsigned long)RIGHTSHIFT;
		  }
#line 3536 "parser.c"
    break;

  case 170: /* complex_imm_arg: complex_imm_const  */
#line 1388 "parser.y"
                                    {
			yyval = yyvsp[0];
		  }
#line 3544 "parser.c"
    break;

  case 171: /* complex_imm_arg: complex_imm  */
#line 1391 "parser.y"
                              {
			yyval = yyvsp[0];
		  }
#line 3552 "parser.c"
    break;

  case 172: /* complex_imm_const: hexnum_decnum  */
#line 1396 "parser.y"
                                  {
			yyval = yyvsp[0];
		  }
#line 3560 "parser.c"
    break;

  case 173: /* complex_imm_const: BITW_NOT hexnum_decnum  */
#line 1399 "parser.y"
                                         {
			unsigned long n = (unsigned long)yyvsp[0];
			n = ~n;
			yyval = (void *)n;
		  }
#line 3570 "parser.c"
    break;

  case 174: /* hexnum: HEXNUM  */
#line 1406 "parser.y"
                         {
			while (yytext[0] != 'x') {
				if (yytext[0] == '\0')
					yyerror("Internal HEXNUM parser error");
				yytext++;
			}
			yytext++;
			yyval = (void *)(unsigned long)strtoul(yytext, NULL, 16);
		  }
#line 3584 "parser.c"
    break;

  case 175: /* decnum: DECNUM  */
#line 1417 "parser.y"
                         {
			yyval = (void *)(unsigned long)strtol(yytext, NULL, 10);
		  }
#line 3592 "parser.c"
    break;

  case 176: /* hexnum_decnum: hexnum  */
#line 1422 "parser.y"
                         {
			yyval = yyvsp[0];
		  }
#line 3600 "parser.c"
    break;

  case 177: /* hexnum_decnum: decnum  */
#line 1425 "parser.y"
                         {
			yyval = yyvsp[0];
		  }
#line 3608 "parser.c"
    break;

  case 178: /* labelref: identifier  */
#line 1430 "parser.y"
                             {
			struct operand *oper = xmalloc(sizeof(struct operand));
			struct label *label = xmalloc(sizeof(struct label));
			label->name = yyvsp[0];
			label->direction = LABELREF_ABSOLUTE;
			oper->type = OPER_LABEL;
			oper->u.label = label;
			yyval = oper;
		  }
#line 3622 "parser.c"
    break;

  case 179: /* labelref: identifier MINUS  */
#line 1439 "parser.y"
                                   {
			struct operand *oper = xmalloc(sizeof(struct operand));
			struct label *label = xmalloc(sizeof(struct label));
			label->name = yyvsp[-1];
			label->direction = LABELREF_RELATIVE_BACK;
			oper->type = OPER_LABEL;
			oper->u.label = label;
			yyval = oper;
		  }
#line 3636 "parser.c"
    break;

  case 180: /* labelref: identifier PLUS  */
#line 1448 "parser.y"
                                  {
			struct operand *oper = xmalloc(sizeof(struct operand));
			struct label *label = xmalloc(sizeof(struct label));
			label->name = yyvsp[-1];
			label->direction = LABELREF_RELATIVE_FORWARD;
			oper->type = OPER_LABEL;
			oper->u.label = label;
			yyval = oper;
		  }
#line 3650 "parser.c"
    break;

  case 181: /* regnr: DECNUM  */
#line 1459 "parser.y"
                         {
			yyval = (void *)(unsigned long)strtoul(yytext, NULL, 10);
		  }
#line 3658 "parser.c"
    break;

  case 182: /* identifier: IDENT  */
#line 1464 "parser.y"
                        {
			yyval = xstrdup(yytext);
		  }
#line 3666 "parser.c"
    break;


#line 3670 "parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1469 "parser.y"


int section = SECTION_TEXT; /* default to .text section */
struct initvals_sect *cur_initvals_sect;

void yyerror(const char *str)
{
	unsigned int i;

	fprintf(stderr,
		"Parser ERROR (file \"%s\", line %u, col %u):\n",
		cur_lineinfo.file,
		cur_lineinfo.lineno,
		cur_lineinfo.column);
	fprintf(stderr, "%s\n", cur_lineinfo.linecopy);
	for (i = 0; i < cur_lineinfo.column - 1; i++)
		fprintf(stderr, " ");
	fprintf(stderr, "^\n");
	fprintf(stderr, "%s\n", str);
	exit(1);
}

static struct operand * store_oper_sanity(struct operand *oper)
{
	if (oper->type == OPER_IMM &&
	    oper->u.imm->imm != 0) {
		yyerror("Only 0x000 Immediate is allowed for "
			"Output operands");
	}
	return oper;
}

static void assembler_assertion_failed(void)
{
	yyerror("Assembler %assert failed");
}
